Note: This is a public test instance of Red Hat Bugzilla. The data contained within is a snapshot of the live data so any changes you make will not be reflected in the production Bugzilla. Email is disabled so feel free to test any aspect of the site that you want. File any problems you find or give feedback at bugzilla.redhat.com.
Bug 2107934 - lilypond package should provide Guile bytecode for reasonable startup speed
Summary: lilypond package should provide Guile bytecode for reasonable startup speed
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: lilypond
Version: 36
Hardware: Unspecified
OS: Unspecified
unspecified
high
Target Milestone: ---
Assignee: Gwyn Ciesla
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2022-07-17 19:39 UTC by Jean Abou Samra
Modified: 2022-12-07 08:19 UTC (History)
2 users (show)

Fixed In Version: lilypond-2.23.11-1.fc36 lilypond-2.23.11-1.fc35 lilypond-2.23.82-1.fc37 lilypond-2.23.82-1.fc36
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2022-12-07 01:35:04 UTC
Type: Bug
Embargoed:


Attachments (Terms of Use)

Description Jean Abou Samra 2022-07-17 19:39:27 UTC
LilyPond switched to Guile 2.2 permanently in version 2.23.7. Fedora currently ships version 2.23.10, the latest development version. (I didn't check whether it was already using Guile 2.2 before 2.23.7).

Unlike Guile 1.8, which is a simple interpreter, Guile 2.2 requires byte-compilation for code to be reasonably fast, and in particular, for code to load reasonably fast. In LilyPond, the make target to produce bytecode is "make bytecode". Note that "make bytecode" is _not_ implied by "make" -- it has to be done explicitly.

Right now, the binaries shipped in Fedora do not contain bytecode, as far as I can see. This makes the startup time a bit painful in edit cycles. Just running `lilypond` (without a file, so it just initializes the engine) takes

real	0m1,454s
user	0m1,410s
sys	0m0,044s

In contrast, for the officially distributed binaries, which do contain bytecode, this is

real	0m0,123s
user	0m0,092s
sys	0m0,030s

In summary, the Fedora package should ship with bytecode in order to provide good startup speed.

Thanks in advance for looking at this.

Jean Abou Samra (developer on LilyPond)

Comment 1 Fedora Update System 2022-07-18 17:19:03 UTC
FEDORA-2022-043e05df68 has been submitted as an update to Fedora 36. https://bodhi.fedoraproject.org/updates/FEDORA-2022-043e05df68

Comment 2 Fedora Update System 2022-07-18 17:19:04 UTC
FEDORA-2022-e8b1460a0d has been submitted as an update to Fedora 35. https://bodhi.fedoraproject.org/updates/FEDORA-2022-e8b1460a0d

Comment 3 Fedora Update System 2022-07-19 01:11:37 UTC
FEDORA-2022-043e05df68 has been pushed to the Fedora 36 testing repository.
Soon you'll be able to install the update with the following command:
`sudo dnf upgrade --enablerepo=updates-testing --refresh --advisory=FEDORA-2022-043e05df68`
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2022-043e05df68

See also https://fedoraproject.org/wiki/QA:Updates_Testing for more information on how to test updates.

Comment 4 Fedora Update System 2022-07-19 01:25:44 UTC
FEDORA-2022-e8b1460a0d has been pushed to the Fedora 35 testing repository.
Soon you'll be able to install the update with the following command:
`sudo dnf upgrade --enablerepo=updates-testing --refresh --advisory=FEDORA-2022-e8b1460a0d`
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2022-e8b1460a0d

See also https://fedoraproject.org/wiki/QA:Updates_Testing for more information on how to test updates.

Comment 5 Fedora Update System 2022-07-26 15:15:36 UTC
FEDORA-2022-5096605469 has been pushed to the Fedora 35 testing repository.
Soon you'll be able to install the update with the following command:
`sudo dnf upgrade --enablerepo=updates-testing --refresh --advisory=FEDORA-2022-5096605469`
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2022-5096605469

See also https://fedoraproject.org/wiki/QA:Updates_Testing for more information on how to test updates.

Comment 6 Fedora Update System 2022-07-26 15:54:31 UTC
FEDORA-2022-f2e003f512 has been pushed to the Fedora 36 testing repository.
Soon you'll be able to install the update with the following command:
`sudo dnf upgrade --enablerepo=updates-testing --refresh --advisory=FEDORA-2022-f2e003f512`
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2022-f2e003f512

See also https://fedoraproject.org/wiki/QA:Updates_Testing for more information on how to test updates.

Comment 7 Fedora Update System 2022-08-03 01:27:01 UTC
FEDORA-2022-f2e003f512 has been pushed to the Fedora 36 stable repository.
If problem still persists, please make note of it in this bug report.

Comment 8 Fedora Update System 2022-08-03 01:49:10 UTC
FEDORA-2022-5096605469 has been pushed to the Fedora 35 stable repository.
If problem still persists, please make note of it in this bug report.

Comment 9 Jean Abou Samra 2022-11-26 00:40:14 UTC
Hi! Sorry for bothering you again. This problem seems not fixed in Fedora 37 (which has LilyPond 2.23.81). I *think* I saw it fixed at some point, but this may be in my imagination.


$ time lilypond
[...]
real	0m1,659s
user	0m1,603s
sys	0m0,053s



In the package spec, I see "make bytecode", but maybe it's missing "make install-bytecode"?

Comment 10 Jean Abou Samra 2022-11-26 00:40:54 UTC
(Taking the liberty to reopen, please tell me if this is not appropriate.)

Comment 11 Gwyn Ciesla 2022-11-28 17:15:50 UTC
Totally appropriate, I'll check it out. Thanks!

Comment 12 Fedora Update System 2022-11-28 20:07:06 UTC
FEDORA-2022-386167291c has been submitted as an update to Fedora 36. https://bodhi.fedoraproject.org/updates/FEDORA-2022-386167291c

Comment 13 Fedora Update System 2022-11-28 20:07:08 UTC
FEDORA-2022-d9d66227fb has been submitted as an update to Fedora 37. https://bodhi.fedoraproject.org/updates/FEDORA-2022-d9d66227fb

Comment 14 Fedora Update System 2022-11-29 02:20:41 UTC
FEDORA-2022-386167291c has been pushed to the Fedora 36 testing repository.
Soon you'll be able to install the update with the following command:
`sudo dnf upgrade --enablerepo=updates-testing --refresh --advisory=FEDORA-2022-386167291c`
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2022-386167291c

See also https://fedoraproject.org/wiki/QA:Updates_Testing for more information on how to test updates.

Comment 15 Fedora Update System 2022-11-29 02:31:26 UTC
FEDORA-2022-d9d66227fb has been pushed to the Fedora 37 testing repository.
Soon you'll be able to install the update with the following command:
`sudo dnf upgrade --enablerepo=updates-testing --refresh --advisory=FEDORA-2022-d9d66227fb`
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2022-d9d66227fb

See also https://fedoraproject.org/wiki/QA:Updates_Testing for more information on how to test updates.

Comment 16 Fedora Update System 2022-12-07 01:35:04 UTC
FEDORA-2022-d9d66227fb has been pushed to the Fedora 37 stable repository.
If problem still persists, please make note of it in this bug report.

Comment 17 Fedora Update System 2022-12-07 01:42:30 UTC
FEDORA-2022-386167291c has been pushed to the Fedora 36 stable repository.
If problem still persists, please make note of it in this bug report.

Comment 18 Jean Abou Samra 2022-12-07 08:19:28 UTC
Thank you! I confirm that after upgrading my system, the version of LilyPond installed from Fedora has normal startup speed.


Note You need to log in before you can comment on or make changes to this bug.